Index: Dev/branches/rest-dojo-ui/client/rft/pages/survey.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/survey.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/survey.js	(revision 410)
@@ -5,5 +5,5 @@
     'dojo/_base/event',
     'dojo/_base/lang',
-    '../app/Controller',
+    '../app/Router',
     '../store',
     '../app/Page',
@@ -11,5 +11,5 @@
     '../ui/TabbedQuestionBrowser',
     'dojo/text!./survey.html'
-],function(array,declare,Deferred,event,lang,Controller,store,Page,
+],function(array,declare,Deferred,event,lang,Router,store,Page,
          QuestionListView,TabbedQuestionBrowser,template){
     return declare([Page],{
@@ -27,11 +27,5 @@
                 this._setupQuestionBrowser();
                 this._setupListView();
-                Deferred.when(store.get(this.surveyId))
-                .then(lang.hitch(this,function(obj){
-                    this.survey = obj;
-                    store.query(null,{keys:this.survey.questions,include_docs:true})
-                    .forEach(lang.hitch(this.questionList,'appendItem'));
-                    this.refresh();
-                }));
+                this._setupSurvey();
             } else {
                 throw "No valid uid or survey passed!";
@@ -42,4 +36,5 @@
                 region: 'center',
                 'class': 'blue',
+                include: 'published',
                 selectedActions: {
                     "Include": {
@@ -59,7 +54,4 @@
             this.questionBrowser.startup();
         },
-        _includeQuestion: function(question) {
-            this.questionList.insertItem(question);
-        },
         _setupListView: function() {
             this.questionList = new QuestionListView({
@@ -67,4 +59,16 @@
             },this.surveyListViewNode);
             this.questionList.startup();
+        },
+        _setupSurvey: function() {
+            Deferred.when(store.get(this.surveyId))
+            .then(lang.hitch(this,function(survey){
+                this.survey = survey;
+                store.query(null,{keys:this.survey.questions || [], include_docs: true})
+                .forEach(lang.hitch(this.questionList,'appendItem'));
+                this.refresh();
+            }));
+        },
+        _includeQuestion: function(question) {
+            this.questionList.insertItem(question);
         },
         refresh: function() {
@@ -94,5 +98,5 @@
             store.put(this.survey)
             .then(function() { 
-                Controller.go('/surveys');
+                Router.go('/surveys');
             });
             event.stop(evt);
@@ -100,7 +104,10 @@
         },
         _onDiscard: function(evt) {
+            Router.go('/surveys');
         },
         _onShowPreview: function() {
-            Controller.go('/viewSurvey/'+store.getIdentity(this.survey));
+            Router.go('/viewSurvey/'+store.getIdentity(this.survey),{
+                preview: true
+            });
         }
     });
Index: Dev/branches/rest-dojo-ui/client/rft/pages/surveys.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/surveys.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/surveys.js	(revision 410)
@@ -1,45 +1,149 @@
 define([
+    'dojo/_base/array',
     'dojo/_base/declare',
     'dojo/_base/lang',
-    'dojo/_base/Deferred',
-    'dojo/data/ObjectStore',
-    '../auth',
+    'dojo/when',
     '../store',
-    '../app/Controller',
+    '../app/Content',
     '../app/Page',
+    '../app/Router',
+    '../ui/LineWithActionsWidget',
     'dojo/text!./surveys.html'
-],function(declare,lang,Deferred,ObjectStore,auth,store,Controller,Page,template){
+],function(array,declare,lang,when,store,Content,Page,Router,LineWithActionsWidget,template){
     return declare([Page],{
         templateString: template,
-        selectedObject: null,
         startup: function() {
             if ( this._started ) { return; }
             this.inherited(arguments);
-            this.grid.setStore(
-                ObjectStore({objectStore: store}),
-                "_design/default/_view/by_type",{key:'Survey'});
-            
-            this.grid.on('rowclick',lang.hitch(this,function(evt){
-                this.selectedObject = evt.grid.getItem(evt.rowIndex);
-                this.btnEdit.set('disabled',!this.selectedObject);
+            this.refresh();
+        },
+        _onNewSurvey: function(){
+            when( store.add({type:'Survey'}) )
+            .then(function(survey) {
+                Router.go('/survey/'+store.getIdentity(survey));
+            });
+        },
+        _onPublishSurvey:function(survey){
+            var self = this;
+            survey.publicationDate = store.timestamp();
+            store.put(survey).then(function(){
+                self.refreshDrafts();
+                self.refreshPublished();
+            },function(err){
+                Content.notify(err.reason,'error');
+            });
+        },
+        _onDeleteSurvey:function(survey){
+            var self = this;
+            store.remove(store.getIdentity(survey),store.getRevision(survey))
+            .then(function(){
+                self.refreshDrafts();
+            },function(err){
+                Content.notify(err.reason,'error');
+            });
+        },
+        _onEditSurvey:function(survey){
+            Router.go('/survey/'+store.getIdentity(survey));
+        },
+        _onPreviewSurvey:function(survey){
+            Router.go('/viewSurvey/'+store.getIdentity(survey),{preview:true});
+        },
+        _onRunSurvey:function(survey){
+
+        },
+        refresh: function() {
+            this.refreshDrafts();
+            this.refreshPublished();
+            this.refreshRuns();
+        },
+        refreshDrafts: function() {
+            this.draftsContainer.set('content','');
+            when(store.query("_design/surveys/_view/drafts")
+                    ,lang.hitch(this,function(surveys){
+                this.draftsTab.set('title','Drafts ('+surveys.length+')');
+                array.forEach(surveys,function(survey){
+                    var w = new LineWithActionsWidget({
+                        title: survey.title || '(unnamed)',
+                        actions: [{
+                            callback: lang.hitch(this,'_onPublishSurvey',survey),
+                            properties: {
+                                label: 'Publish',
+                                tooltip: 'Publish survey',
+                                icon: 'Publish'
+                            }
+                        },{
+                            callback: lang.hitch(this,'_onPreviewSurvey',survey),
+                            properties: {
+                                label: 'Preview',
+                                tooltip: 'Preview survey',
+                                icon: 'Preview'
+                            }
+                        },{
+                            callback: lang.hitch(this,'_onDeleteSurvey',survey),
+                            properties: {
+                                label: 'Delete',
+                                tooltip: 'Delete survey',
+                                icon: 'Delete'
+                            }
+                        },{
+                            callback: lang.hitch(this,'_onEditSurvey',survey),
+                            properties: {
+                                label: 'Edit',
+                                tooltip: 'Edit survey',
+                                icon: 'Edit'
+                            }
+                        }]
+                    });
+                    this.draftsContainer.addChild(w);
+                },this);
             }));
-
-            this.grid.on('rowdblclick',lang.hitch(this,function(evt){
-                var obj = evt.grid.getItem(evt.rowIndex);
-                Controller.go('/survey/'+store.getIdentity(obj));
+        },
+        refreshPublished: function() {
+            this.publishedContainer.set('content','');
+            when(store.query("_design/surveys/_view/published")
+                    ,lang.hitch(this,function(surveys){
+                this.publishedTab.set('title','Published ('+surveys.length+')');
+                array.forEach(surveys,function(survey){
+                    var w = new LineWithActionsWidget({
+                        title: survey.title,
+                        actions:[{
+                            callback: lang.hitch(this,'_onPreviewSurvey',survey),
+                            properties: {
+                                label: 'Preview',
+                                tooltip: 'Preview survey',
+                                icon: 'Preview'
+                            }
+                        },{
+                            callback: lang.hitch(this,'_onRunSurvey',survey),
+                            properties: {
+                                label: 'Run',
+                                tooltip: 'Run survey',
+                                icon: 'Run'
+                            }
+                        }]
+                    });
+                    this.publishedContainer.addChild(w);
+                },this);
             }));
-            
-            this.btnNew.on('click',lang.hitch(this,function(){
-                Deferred.when( store.add({type:'Survey',creator:auth.getUser()}) )
-                .then(function(obj) {
-                    Controller.go('/survey/'+store.getIdentity(obj));
-                });
-            }));
-
-            this.btnEdit.on('click',lang.hitch(this,function(){
-                if ( this.selectedObject ) {
-                    Controller.go('/survey/'+store.getIdentity(this.selectedObject));
-                }
-                
+        },
+        refreshRuns: function() {
+            this.runsContainer.set('content','');
+            when(store.query("_design/default/_view/by_type",{key:'SurveyRun'})
+                    ,lang.hitch(this,function(surveyRuns){
+                this.runsTab.set('title','Runs ('+surveyRuns.length+')');
+                array.forEach(surveyRuns,function(surveyRun){
+                    var w = new LineWithActionsWidget({
+                        title: survey.title,
+                        actions:[{
+                            callback: lang.hitch(this,'_onCloseRun',surveyRun),
+                            properties: {
+                                label: 'Close',
+                                tooltip: 'Close survey',
+                                icon: 'Close'
+                            }
+                        }]
+                    });
+                    this.runsContainer.addChild(w);
+                },this);
             }));
         }
Index: Dev/branches/rest-dojo-ui/client/rft/pages/viewSurvey.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/pages/viewSurvey.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/pages/viewSurvey.js	(revision 410)
@@ -13,15 +13,28 @@
         templateString: template,
         survey: null,
+        surveyId: "",
+        options: null,
         constructor: function(){
             this._dataMap = {};
+            this.options = this.options || {};
         },
         startup: function() {
             if ( this._started ) { return; }
             this.inherited(arguments);
+
+
             if ( this.surveyId ) {
                 Deferred.when(store.get(this.surveyId))
-                .then(lang.hitch(this,function(obj){
+                .then(lang.hitch(this,function(survey){
+                    if ( !survey.published ) {
+                        this.options.preview = true;
+                    }
+                    if ( this.options.preview ) {
+                        this.buttonsPane.destroyRecursive();
+                    }
+                    this.titleNode.innerHTML = survey.title +
+                            (this.options.preview?' [preview]':'');
                     var f = new ContentWidgetFactory();
-                    this.survey = obj;
+                    this.survey = survey;
                     store.query(null,{keys:this.survey.questions,include_docs:true})
                     .forEach(function(question){
@@ -37,8 +50,9 @@
                 }));
             } else {
-                throw "No valid uid or survey passed!";
+                throw new Error("No valid uid or survey passed!");
             }
         },
         _onSubmit: function(evt) {
+            if ( this.options.preview ) { return; }
             var value = this.questionsForm.get('value');
             this.questionsPane.set('content','<pre>'+JSON.stringify(value)+'</pre>');
@@ -47,4 +61,5 @@
         },
         _onCancel: function(evt) {
+            if ( this.options.preview ) { return; }
             event.stop(evt);
             return false;
Index: Dev/branches/rest-dojo-ui/client/rft/run.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/run.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/run.js	(revision 410)
@@ -2,13 +2,13 @@
     'dojo/_base/array',
     'dojo/parser',
-    'rft/app/Controller',
+    'rft/app/Router',
     'rft/routes',
     'rft/stddeps',
     'dojo/domReady!'
-],function(array,parser,controller,routes) {
+],function(array,parser,router,routes) {
     parser.parse();
     array.forEach(routes,function(route){
-        controller.register(route);
+        router.register(route);
     });
-    controller.startup();
+    router.startup();
 });
Index: Dev/branches/rest-dojo-ui/client/rft/search.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/search.js	(revision 410)
+++ Dev/branches/rest-dojo-ui/client/rft/search.js	(revision 410)
@@ -0,0 +1,9 @@
+define([
+    './store/ElasticReadStore'
+],function(ElasticReadStore){
+    return new ElasticReadStore({
+        url: "data/elastic",
+        requestMethod: "POST"
+    });
+
+});
Index: Dev/branches/rest-dojo-ui/client/rft/store.js
===================================================================
--- Dev/branches/rest-dojo-ui/client/rft/store.js	(revision 409)
+++ Dev/branches/rest-dojo-ui/client/rft/store.js	(revision 410)
@@ -1,256 +1,18 @@
 define([
-    'dojo/_base/array',
-    'dojo/_base/declare',
-    'dojo/_base/Deferred',
-    'dojo/_base/json',
-    'dojo/_base/lang',
-    'dojo/_base/xhr',
-    'dojo/store/util/QueryResults'
-],function(array,declare,Deferred,json,lang,xhr,QueryResults){
+    'dojo/date/stamp',
+    './store/CouchStore'
+],function(stamp,CouchStore){
     
-    var CouchStore = declare(null, {
-        /** dojo Store implementation for CouchDB
-         *
-         * See for details on the REST API, the wiki
-         * at http://wiki.apache.org/couchdb/HTTP_Document_API.
-         */
-        target: "",
-        accepts: "application/json", 
-        idProperty: "_id",
-        revProperty: "_rev",
-        _responseIdProperty: "id",
-        _responseRevProperty: "rev",
-        constructor: function(options){
-            declare.safeMixin(this, options);
-        },
-        getIdentity: function(object){
-            return object[this.idProperty];
-        },
-        getRevision: function(object){
-            return object[this.revProperty];
-        },
-        get: function(id){
-            var dfd = new Deferred();
-            xhr("GET", {
-                url: this.target + id,
-                handleAs: "json",
-                headers: {
-                    Accept: this.accepts
-                }
-            }).then(function(result){
-                if ( result.error ) {
-                    dfd.reject(result.reason);
-                } else {
-                    dfd.resolve(result);
-                }
-            }, function(err){
-                dfd.reject(err);
-            });
-            return dfd.promise;
-        },
-        put: function(object, options){
-             // summary:
-             //     put an object in CouchDB
-             // object: Object
-             //     The object to put
-             // options: Object
-             //     Options object as
-             //         id: String
-             //
-            options = options || {};
-
-            var dfd = new Deferred();
-            var id = options.id ? options.id : this.getIdentity(object);
-            var hasId = typeof id != "undefined";
-            xhr(hasId ? "PUT" : "POST", {
-                url: hasId ? this.target + id : this.target,
-                postData: json.toJson(object),
-                handleAs: "json",
-                headers:{
-                    "Content-Type": "application/json",
-                    Accept: this.accepts
-                }
-            }).then(lang.hitch(this,function(result){
-                if ( result.error ) {
-                    dfd.reject(result.reason);
-                } else {
-                    object[this.idProperty] = result[this._responseIdProperty];
-                    object[this.revProperty] = result[this._responseRevProperty];
-                    dfd.resolve(object);
-                }
-            }), function(err){
-                dfd.reject(err);
-            });
-            return dfd.promise;
-        },
-        add: function(object, options){
-            return this.put(object,options);
-        },
-        remove: function(id,rev){
-            var dfd = new Deferred();
-            xhr("DELETE",{
-                url: this.target + id,
-                headers: {
-                    'If-Match': rev
-                }
-            }).then(function(result){
-                if ( result.error ) {
-                    dfd.reject(result.reason);
-                } else {
-                    dfd.resolve();
-                }
-            },function(err){
-                dfd.reject(err);
-            });
-            return dfd.promise;
-        },
-        query: function(query, options){
-            // summary:
-            //    query a couchdb view
-            // query: String
-            //    name of a couchdb view you want to query, relative to the current database
-            // options: Object
-            //     options object as
-            //        start: Number
-            //            Start results at this item
-            //        count: Number
-            //            Number of items to return
-            //        sort: [{attribute:'key',descending:true|false}]
-            //            CouchDB only support sorting by key, so only 'key'
-            //            is allowed as attribute value. Multiple sort items
-            //            are ignored.
-            //        key: String|Array|Object
-            //            Return only values with this key.
-            //            Excludes start/endkey usage.
-            //        startkey: String|Array|Object
-            //            Return values starting from this key.
-            //        endkey: String|Array|Object
-            //            Return values with key lower than this key.
-            //        include_docs: true|false
-            //            Return the full documents instead of the view
-            //            values.
-            //        reduce: true|false
-            //            Execute reduce on the view or not. Default depends
-            //            on if a reduce function is defined on the view.
-            //        group: true|false
-            //            Should values be grouped per key or not? Default
-            //            is false.
-            //        group_level: Number
-            //            When group = true and the key is an array,
-            //            determines which elements starting from the first
-            //            are used for grouping. Default is 0.
-            //        get_keys: true|false
-            //            Instead of returning the values or documents,
-            //            return the array of keys as the result.
-            //            This does not affect the forPairs function.
-            options = options || {};
-
-            var dfd = new Deferred();
-            var queryOpts = {};
-            if ( !query ) {
-                query = '_all_docs';
-            }
-
-            if (!lang.isString(query)) {
-                console.warn("Query must be a view name");
-            }
-
-            // Standard options
-            if (options.start >= 0) {
-                queryOpts.skip = options.start;
-            }
-            if (options.count >= 0) {
-                queryOpts.limit = options.count;
-            }
-            if (options.sort) {
-                if (options.sort[0]) {
-                    if (options.sort[0].attribute && options.sort[0].attribute !== "key") {
-                        console.warn("Can only sort on key");
-                    }
-                    if (options.sort[0].descending) {
-                        queryOpts.descending = true;
-                    }
-                }
-                if (options.sort.length > 1) {
-                    console.warn("multiple sort fields not supported");
-                }
-            }
-
-            // Custom options
-            if (options.key !== undefined) {
-                queryOpts.key = options.key;
-            } else if (options.keys !== undefined) {
-                queryOpts.keys = options.keys;
-            } else if (options.startkey !== undefined || options.endkey !== undefined) {
-                queryOpts.startkey = options.startkey;
-                queryOpts.endkey = options.endkey;
-            }
-            if (options.include_docs !== undefined) {
-                queryOpts.include_docs = options.include_docs;
-            }
-            if (options.reduce !== undefined) {
-                queryOpts.reduce = options.reduce;
-            }
-            if (options.group !== undefined) {
-                queryOpts.group = options.group;
-                if (options.group_level !== undefined) {
-                    queryOpts.group_level = options.group_level;
-                }
-            }
-
-            for (var qp in queryOpts) {
-                queryOpts[qp] = json.toJson(queryOpts[qp]);
-            }
-            query += '?' + xhr.objectToQuery(queryOpts);
-
-            xhr("GET", {
-                url: this.target + query,
-                handleAs: "json",
-                headers: {
-                    Accept: this.accepts
-                }
-            }).then(function(result){
-                if (result.error) {
-                    dfd.reject(result.reason);
-                } else  {
-                    var results;
-                    var values = array.map(result.rows,function(result){
-                        return options.include_docs === true ? result.doc : result.value;
-                    });
-                    var keys = array.map(result.rows,function(result){
-                        return result.key;
-                    });
-                    if (options.get_keys === true) {
-                        results = keys;
-                        results.values = values;
-                    } else {
-                        results = values;
-                        results.keys = keys;
-                    }
-                    dfd.resolve(results);
-                }
-            },function(err){
-                dfd.reject(err);
-            });
-            return CouchResults(dfd.promise);
-        }
-    });
-
-    function CouchResults(results) {
-        results = QueryResults(results);
-        results.forPairs = function(callback,thisObject) {
-            callback = lang.hitch(thisObject,callback);
-            return Deferred.when(results,function(results) {
-                var values = results.values || results;
-                var keys = results.keys || results;
-                return array.forEach(values, function(value,index) {
-                    callback(value,keys[index],index);
-                });
-            });
-        };
-        return results;
-    }
-
-    return new CouchStore({target: 'data/rft/'});
+    var store = new CouchStore({target: 'data/couch/'});
+    store.formatDate = function(date){
+        return stamp.toISOString(date,{zulu:true});
+    };
+    store.parseDate = function(dateString){
+        return stamp.fromISOString(dateString);
+    };
+    store.timestamp = function() {
+        return this.formatDate(new Date());
+    };
+    return store;
 
 });
